#ifndef STOP_WATCH_H
#define STOP_WATCH_H

#include "watch_access.h"
#include "stopped_state.h"

class stop_watch
{
 public:

  void start();

  void stop();

 private:

  // Meyers Item 39: Prefer public inheritance plus composition in favour of private inheritance.
  class state_controller : public watch_access
  {
      watch_state_ptr current_state;

    public:
      state_controller()
      {
         watch_access::change_state_to<stopped_state>();
      }

      // Hide the extra indirection for the client by using en masse delegation.
      watch_state_ptr operator->() const
      {
         return current_state;
      }

   private:
      virtual void change_state_to(watch_state_ptr new_state)
      {
         current_state = new_state;
      }
    };
  
  state_controller state;
};

#endif


