#ifndef STOP_WATCH_H
#define STOP_WATCH_H

#include "watch_access.h"

class watch_state;

class stop_watch
{
 public:
  stop_watch();

  void start();

  void stop();

 private:

  // Meyers Item 39: Prefer public inheritance plus composition in favour of private inheritance.
  class state_controller : public watch_access
  {
      watch_state* current_state;

    public:
      state_controller(watch_state* initial_state)
         : current_state(initial_state)
      {
      }

      // Hide the extra indirection for the client by using en masse delegation.
      watch_state* operator->() const
      {
         return current_state;
      }

      virtual void change_state_to(watch_state* new_state)
      {
         current_state = new_state;
      }
    };
  
  state_controller state;
};

#endif


